$(() => {
const form = $('#form').dxForm({
labelMode: 'floating',
formData: companies[0],
readOnly: false,
showColonAfterLabel: true,
labelLocation: 'left',
minColWidth: 300,
colCount: 2,
}).dxForm('instance');
const companySelectorSelectBox = $('#select-company').dxSelectBox({
displayExpr: 'Name',
dataSource: companies,
inputAttr: { 'aria-label': 'Company' },
labelMode: 'floating',
label: 'Select company',
value: companies[0],
onValueChanged(data) {
form.option('formData', data.value);
},
}).dxSelectBox('instance');
const companySelectorText = $('#select-company-text');
$('#label-mode').dxSelectBox({
items: ['outside', 'static', 'floating', 'hidden'],
value: 'floating',
inputAttr: { 'aria-label': 'Label Mode' },
onValueChanged(data) {
form.option('labelMode', data.value);
if (data.value === 'outside') {
companySelectorSelectBox.option('labelMode', 'hidden');
companySelectorText.show();
} else {
companySelectorSelectBox.option('labelMode', data.value);
companySelectorText.hide();
}
},
});
$('#label-location').dxSelectBox({
items: ['left', 'top'],
value: 'left',
inputAttr: { 'aria-label': 'Label Location' },
onValueChanged(data) {
form.option('labelLocation', data.value);
},
});
$('#columns-count').dxSelectBox({
items: ['auto', 1, 2, 3],
inputAttr: { 'aria-label': 'Column Count' },
value: 2,
onValueChanged(data) {
form.option('colCount', data.value);
},
});
$('#min-column-width').dxSelectBox({
items: [150, 200, 300],
inputAttr: { 'aria-label': 'Min Column Width' },
value: 300,
onValueChanged(data) {
form.option('minColWidth', data.value);
},
});
$('#width').dxNumberBox({
value: undefined,
max: 550,
inputAttr: { 'aria-label': 'Width' },
onValueChanged(data) {
form.option('width', data.value);
},
});
$('#read-only').dxCheckBox({
text: 'readOnly',
value: false,
onValueChanged(data) {
form.option('readOnly', data.value);
},
});
$('#show-colon').dxCheckBox({
text: 'showColonAfterLabel',
value: true,
onValueChanged(data) {
form.option('showColonAfterLabel', data.value);
},
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.6/css/dx.light.css" />
<script src="https://cdn3.devexpress.com/jslib/23.1.6/js/dx.all.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="form-demo">
<div class="widget-container">
<div id="select-company-text">Select company:</div>
<div id="select-company"></div>
<div id="form"></div>
</div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Label mode:</span>
<div id="label-mode"></div>
</div>
<div class="option">
<span>Label location:</span>
<div id="label-location"></div>
</div>
<div class="option">
<span>Columns count:</span>
<div id="columns-count"></div>
</div>
<div class="option">
<span>Min column width:</span>
<div id="min-column-width"></div>
</div>
<div class="option">
<span>Form width:</span>
<div id="width"></div>
</div>
<div class="option">
<div id="read-only"></div>
</div>
<div class="option">
<div id="show-colon"></div>
</div>
</div>
</div>
</div>
</body>
</html>
.widget-container {
margin-right: 320px;
padding: 20px;
max-width: 550px;
min-width: 300px;
}
#form {
margin-top: 25px;
}
#select-company-text {
display: none;
}
.options {
padding: 20px;
position: absolute;
bottom: 0;
right: 0;
width: 260px;
top: 0;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
}
const companies = [{
ID: 1,
Name: 'Super Mart of the West',
Address: '702 SW 8th Street',
City: 'Bentonville',
State: 'Arkansas',
ZipCode: 72716,
Phone: '(800) 555-2797',
Fax: '(800) 555-2171',
Website: '',
Active: true,
}, {
ID: 2,
Name: 'Electronics Depot',
Address: '2455 Paces Ferry Road NW',
City: 'Atlanta',
State: 'Georgia',
ZipCode: 30339,
Phone: '(800) 595-3232',
Fax: '(800) 595-3231',
Website: '',
Active: true,
}, {
ID: 3,
Name: 'K&S Music',
Address: '1000 Nicllet Mall',
City: 'Minneapolis',
State: 'Minnesota',
ZipCode: 55403,
Phone: '(612) 304-6073',
Fax: '(612) 304-6074',
Website: '',
Active: true,
}, {
ID: 4,
Name: "Tom's Club",
Address: '999 Lake Drive',
City: 'Issaquah',
State: 'Washington',
ZipCode: 98027,
Phone: '(800) 955-2292',
Fax: '(800) 955-2293',
Website: '',
Active: true,
}];

<div id="form-demo">
<div class="widget-container">
<div *ngIf="labelMode === 'outside'">Select company:</div>
<dx-select-box
#company
displayExpr="Name"
[inputAttr]="{ 'aria-label': 'Company' }"
[(dataSource)]="companies"
label="Select company"
[labelMode]="getCompanySelectorLabelMode()"
[value]="companies[0]"
></dx-select-box>
<dx-form
id="form"
[(formData)]="company.value"
[readOnly]="readOnly"
[labelMode]="labelMode"
[showColonAfterLabel]="showColon"
[labelLocation]="labelLocation"
[minColWidth]="minColWidth"
[colCount]="colCount"
[width]="width"
></dx-form>
</div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Label mode:</span>
<dx-select-box
[items]="['outside', 'static', 'floating', 'hidden']"
[inputAttr]="{ 'aria-label': 'Label Mode' }"
[(value)]="labelMode"
></dx-select-box>
</div>
<div class="option">
<span>Label location:</span>
<dx-select-box
[items]="['left', 'top']"
[inputAttr]="{ 'aria-label': 'Label Location' }"
[(value)]="labelLocation"
></dx-select-box>
</div>
<div class="option">
<span>Columns count:</span>
<dx-select-box
[items]="['auto', 1, 2, 3]"
[inputAttr]="{ 'aria-label': 'Column Count' }"
[(value)]="colCount"
></dx-select-box>
</div>
<div class="option">
<span>Min column width:</span>
<dx-select-box
[items]="[150, 200, 300]"
[inputAttr]="{ 'aria-label': 'Min Column Width' }"
[(value)]="minColWidth"
></dx-select-box>
</div>
<div class="option">
<span>Form width:</span>
<dx-number-box
[max]="550"
[(value)]="width"
[inputAttr]="{ 'aria-label': 'Form Width' }"
></dx-number-box>
</div>
<div class="option">
<dx-check-box text="readOnly" [(value)]="readOnly"></dx-check-box>
</div>
<div class="option">
<dx-check-box
text="showColonAfterLabel"
[(value)]="showColon"
></dx-check-box>
</div>
</div>
</div>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule, BrowserTransferStateModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import {
DxCheckBoxModule,
DxSelectBoxModule,
DxNumberBoxModule,
DxFormModule,
} from 'devextreme-angular';
import { Company, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
providers: [Service],
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
})
export class AppComponent {
companies: Company[];
labelMode: string;
labelLocation: string;
readOnly: boolean;
showColon: boolean;
minColWidth: number;
colCount: number;
width: any;
constructor(service: Service) {
this.labelMode = 'floating';
this.labelLocation = 'left';
this.readOnly = false;
this.showColon = true;
this.minColWidth = 300;
this.colCount = 2;
this.companies = service.getCompanies();
}
getCompanySelectorLabelMode() {
return this.labelMode === 'outside'
? 'hidden'
: this.labelMode;
}
}
@NgModule({
imports: [
BrowserModule,
BrowserTransferStateModule,
DxCheckBoxModule,
DxSelectBoxModule,
DxNumberBoxModule,
DxFormModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep .widget-container {
margin-right: 320px;
padding: 20px;
max-width: 550px;
min-width: 300px;
}
::ng-deep #form {
margin-top: 25px;
}
::ng-deep .options {
padding: 20px;
position: absolute;
bottom: 0;
right: 0;
width: 260px;
top: 0;
background-color: rgba(191, 191, 191, 0.15);
}
::ng-deep .caption {
font-size: 18px;
font-weight: 500;
}
::ng-deep.option {
margin-top: 10px;
}
import { Injectable } from '@angular/core';
export class Company {
ID: number;
Name: string;
Address: string;
City: string;
State: string;
ZipCode: number;
Phone: string;
Fax: string;
Website: string;
Active: boolean;
}
const companies: Company[] = [{
ID: 1,
Name: 'Super Mart of the West',
Address: '702 SW 8th Street',
City: 'Bentonville',
State: 'Arkansas',
ZipCode: 72716,
Phone: '(800) 555-2797',
Fax: '(800) 555-2171',
Website: '',
Active: true,
}, {
ID: 2,
Name: 'Electronics Depot',
Address: '2455 Paces Ferry Road NW',
City: 'Atlanta',
State: 'Georgia',
ZipCode: 30339,
Phone: '(800) 595-3232',
Fax: '(800) 595-3231',
Website: '',
Active: true,
}, {
ID: 3,
Name: 'K&S Music',
Address: '1000 Nicllet Mall',
City: 'Minneapolis',
State: 'Minnesota',
ZipCode: 55403,
Phone: '(612) 304-6073',
Fax: '(612) 304-6074',
Website: '',
Active: true,
}, {
ID: 4,
Name: "Tom's Club",
Address: '999 Lake Drive',
City: 'Issaquah',
State: 'Washington',
ZipCode: 98027,
Phone: '(800) 955-2292',
Fax: '(800) 955-2293',
Website: '',
Active: true,
}];
@Injectable()
export class Service {
getCompanies() : Company[] {
return companies;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'@angular/core': 'npm:@angular/core@12.2.17',
'@angular/platform-browser': 'npm:@angular/platform-browser@12.2.17',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic@12.2.17',
'@angular/forms': 'npm:@angular/forms@12.2.17',
'@angular/common': 'npm:@angular/common@12.2.17',
'@angular/compiler': 'npm:@angular/compiler@12.2.17',
'tslib': 'npm:tslib@2.3.1/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@23.1.6/cjs',
'devextreme/bundles/dx.all': 'npm:devextreme@23.1.6/bundles/dx.all.js',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.6.2/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.2',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.49',
'devextreme-angular': 'npm:devextreme-angular@23.1.6',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.4/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.12/inferno/package.json',
'npm:@angular/*/package.json',
'npm:@angular/common@12.2.17/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devextreme-angular@23.1.6/*/package.json',
'npm:devextreme-angular@23.1.6/ui/*/package.json',
'npm:devextreme-angular@23.1.6/package.json',
'npm:devexpress-diagram@2.2.2/package.json',
'npm:devexpress-gantt@4.1.49/package.json',
],
};
System.config(window.config);
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.5/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.12.0/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

<template>
<div id="form-demo">
<div class="widget-container">
<div v-if="labelMode === 'outside'">Select company:</div>
<DxSelectBox
:data-source="companies"
:label-mode="companySelectorLabelMode"
:input-attr="{ 'aria-label': 'Company' }"
label="Select company"
v-model:value="company"
display-expr="Name"
/>
<DxForm
id="form"
:form-data="company"
:label-mode="labelMode"
:read-only="readOnly"
:show-colon-after-label="showColon"
:label-location="labelLocation"
:min-col-width="minColWidth"
:col-count="colCount"
:width="width"
/>
</div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Label mode:</span>
<DxSelectBox
:items="labelModes"
:input-attr="{ 'aria-label': 'Label Mode' }"
v-model:value="labelMode"
/>
</div>
<div class="option">
<span>Label location:</span>
<DxSelectBox
:items="labelLocations"
:input-attr="{ 'aria-label': 'Label Location' }"
v-model:value="labelLocation"
/>
</div>
<div class="option">
<span>Columns count:</span>
<DxSelectBox
:items="columnsCounts"
:input-attr="{ 'aria-label': 'Column Count' }"
v-model:value="colCount"
/>
</div>
<div class="option">
<span>Min column width:</span>
<DxSelectBox
:items="minColumnWidths"
:input-attr="{ 'aria-label': 'Min Column Width' }"
v-model:value="minColWidth"
/>
</div>
<div class="option">
<span>Form width:</span>
<DxNumberBox
:max="550"
v-model:value="width"
:input-attr="{ 'aria-label': 'Form Width' }"
/>
</div>
<div class="option">
<DxCheckBox
v-model:value="readOnly"
text="readOnly"
/>
</div>
<div class="option">
<DxCheckBox
v-model:value="showColon"
text="showColonAfterLabel"
/>
</div>
</div>
</div>
</template>
<script>
import DxCheckBox from 'devextreme-vue/check-box';
import DxSelectBox from 'devextreme-vue/select-box';
import DxNumberBox from 'devextreme-vue/number-box';
import DxForm from 'devextreme-vue/form';
import service from './data.js';
const labelModes = ['outside', 'static', 'floating', 'hidden'];
const labelLocations = ['left', 'top'];
const columnsCounts = ['auto', 1, 2, 3];
const minColumnWidths = [150, 200, 300];
const companies = service.getCompanies();
export default {
components: {
DxCheckBox,
DxSelectBox,
DxNumberBox,
DxForm,
},
data() {
return {
labelMode: 'floating',
labelLocation: 'left',
readOnly: false,
showColon: true,
minColWidth: 300,
colCount: 2,
companies,
company: companies[0],
width: null,
labelModes,
labelLocations,
columnsCounts,
minColumnWidths,
};
},
computed: {
companySelectorLabelMode() {
if (this.labelMode === 'outside') {
return 'hidden';
}
return this.labelMode;
},
},
};
</script>
<style scoped>
.widget-container {
margin-right: 320px;
padding: 20px;
max-width: 550px;
min-width: 300px;
}
#form {
margin-top: 25px;
}
.options {
padding: 20px;
position: absolute;
bottom: 0;
right: 0;
width: 260px;
top: 0;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
}
</style>
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.5/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
const companies = [{
ID: 1,
Name: 'Super Mart of the West',
Address: '702 SW 8th Street',
City: 'Bentonville',
State: 'Arkansas',
ZipCode: 72716,
Phone: '(800) 555-2797',
Fax: '(800) 555-2171',
Website: '',
Active: true,
}, {
ID: 2,
Name: 'Electronics Depot',
Address: '2455 Paces Ferry Road NW',
City: 'Atlanta',
State: 'Georgia',
ZipCode: 30339,
Phone: '(800) 595-3232',
Fax: '(800) 595-3231',
Website: '',
Active: true,
}, {
ID: 3,
Name: 'K&S Music',
Address: '1000 Nicllet Mall',
City: 'Minneapolis',
State: 'Minnesota',
ZipCode: 55403,
Phone: '(612) 304-6073',
Fax: '(612) 304-6074',
Website: '',
Active: true,
}, {
ID: 4,
Name: "Tom's Club",
Address: '999 Lake Drive',
City: 'Issaquah',
State: 'Washington',
ZipCode: 98027,
Phone: '(800) 955-2292',
Fax: '(800) 955-2293',
Website: '',
Active: true,
}];
export default {
getCompanies() {
return companies;
},
};
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'root:': '../../../../../',
'npm:': 'https://unpkg.com/',
},
map: {
'vue': 'npm:vue@3.3.4/dist/vue.esm-browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.1/index.js',
'demo-ts-loader': 'root:utils/demo-ts-loader.js',
'svg-loader': 'root:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@23.1.6/cjs',
'devextreme-vue': 'npm:devextreme-vue@23.1.6',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.6.2/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.2/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.49/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.4/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.12/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);

import React from 'react';
import CheckBox from 'devextreme-react/check-box';
import SelectBox from 'devextreme-react/select-box';
import NumberBox from 'devextreme-react/number-box';
import Form from 'devextreme-react/form';
import service from './data.js';
const labelModes = ['outside', 'static', 'floating', 'hidden'];
const labelLocations = ['left', 'top'];
const columnsCount = ['auto', 1, 2, 3];
const minColumnWidths = [150, 200, 300];
const widthLabel = { 'aria-label': 'Width' };
const companyLabel = { 'aria-label': 'Company' };
const labelModeLabel = { 'aria-label': 'Label Mode' };
const labelLocationLabel = { 'aria-label': 'Label Location' };
const columnCountLabel = { 'aria-label': 'Column Count' };
const minCountWidthLabel = { 'aria-label': 'Min Count Width' };
class App extends React.Component {
constructor() {
super();
this.companies = service.getCompanies();
this.state = {
labelMode: 'floating',
labelLocation: 'left',
readOnly: false,
showColon: true,
minColWidth: 300,
colCount: 2,
company: this.companies[0],
};
this.onCompanyChanged = this.onCompanyChanged.bind(this);
this.onLabelModeChanged = this.onLabelModeChanged.bind(this);
this.onLabelLocationChanged = this.onLabelLocationChanged.bind(this);
this.onReadOnlyChanged = this.onReadOnlyChanged.bind(this);
this.onShowColonChanged = this.onShowColonChanged.bind(this);
this.onMinColWidthChanged = this.onMinColWidthChanged.bind(this);
this.onColumnsCountChanged = this.onColumnsCountChanged.bind(this);
this.onFormWidthChanged = this.onFormWidthChanged.bind(this);
}
render() {
const {
labelMode,
labelLocation,
readOnly,
showColon,
minColWidth,
colCount,
company,
width,
} = this.state;
const companySelectorLabelMode = labelMode === 'outside'
? 'hidden'
: labelMode;
return (
<div id="form-demo">
<div className="widget-container">
{ labelMode === 'outside' && (<div>Select company:</div>) }
<SelectBox
displayExpr="Name"
dataSource={this.companies}
inputAttr={companyLabel}
labelMode={companySelectorLabelMode}
label='Select company'
value={company}
onValueChanged={this.onCompanyChanged}
/>
<Form
id="form"
labelMode={labelMode}
formData={company}
readOnly={readOnly}
showColonAfterLabel={showColon}
labelLocation={labelLocation}
minColWidth={minColWidth}
colCount={colCount}
width={width}
/>
</div>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<span>Label mode:</span>
<SelectBox
items={labelModes}
inputAttr={labelModeLabel}
value={labelMode}
onValueChanged={this.onLabelModeChanged}
/>
</div>
<div className="option">
<span>Label location:</span>
<SelectBox
items={labelLocations}
inputAttr={labelLocationLabel}
value={labelLocation}
onValueChanged={this.onLabelLocationChanged}
/>
</div>
<div className="option">
<span>Columns count:</span>
<SelectBox
items={columnsCount}
value={colCount}
inputAttr={columnCountLabel}
onValueChanged={this.onColumnsCountChanged}
/>
</div>
<div className="option">
<span>Min column width:</span>
<SelectBox
items={minColumnWidths}
value={minColWidth}
inputAttr={minCountWidthLabel}
onValueChanged={this.onMinColWidthChanged}
/>
</div>
<div className="option">
<span>Form width:</span>
<NumberBox
max={550}
value={width}
inputAttr={widthLabel}
onValueChanged={this.onFormWidthChanged}
/>
</div>
<div className="option">
<CheckBox
text="readOnly"
value={readOnly}
onValueChanged={this.onReadOnlyChanged}
/>
</div>
<div className="option">
<CheckBox
text="showColonAfterLabel"
value={showColon}
onValueChanged={this.onShowColonChanged}
/>
</div>
</div>
</div>
);
}
onCompanyChanged(e) {
this.setState({
company: e.value,
});
}
onLabelModeChanged(e) {
this.setState({
labelMode: e.value,
});
}
onLabelLocationChanged(e) {
this.setState({
labelLocation: e.value,
});
}
onReadOnlyChanged(e) {
this.setState({
readOnly: e.value,
});
}
onShowColonChanged(e) {
this.setState({
showColon: e.value,
});
}
onMinColWidthChanged(e) {
this.setState({
minColWidth: e.value,
});
}
onColumnsCountChanged(e) {
this.setState({
colCount: e.value,
});
}
onFormWidthChanged(e) {
this.setState({
width: e.value,
});
}
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.5/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.widget-container {
margin-right: 320px;
padding: 20px;
max-width: 550px;
min-width: 300px;
}
#form {
margin-top: 25px;
}
.options {
padding: 20px;
position: absolute;
bottom: 0;
right: 0;
width: 260px;
top: 0;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
}
const companies = [{
ID: 1,
Name: 'Super Mart of the West',
Address: '702 SW 8th Street',
City: 'Bentonville',
State: 'Arkansas',
ZipCode: 72716,
Phone: '(800) 555-2797',
Fax: '(800) 555-2171',
Website: '',
Active: true,
}, {
ID: 2,
Name: 'Electronics Depot',
Address: '2455 Paces Ferry Road NW',
City: 'Atlanta',
State: 'Georgia',
ZipCode: 30339,
Phone: '(800) 595-3232',
Fax: '(800) 595-3231',
Website: '',
Active: true,
}, {
ID: 3,
Name: 'K&S Music',
Address: '1000 Nicllet Mall',
City: 'Minneapolis',
State: 'Minnesota',
ZipCode: 55403,
Phone: '(612) 304-6073',
Fax: '(612) 304-6074',
Website: '',
Active: true,
}, {
ID: 4,
Name: "Tom's Club",
Address: '999 Lake Drive',
City: 'Issaquah',
State: 'Washington',
ZipCode: 98027,
Phone: '(800) 955-2292',
Fax: '(800) 955-2293',
Website: '',
Active: true,
}];
export default {
getCompanies() {
return companies;
},
};
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
defaultExtension: 'js',
map: {
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.8.1/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@23.1.6/cjs',
'devextreme-react': 'npm:devextreme-react@23.1.6',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.6.2/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.2/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.49/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.4/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.12/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);